package dev.inmo.postssystem.features.roles.client

import dev.inmo.postssystem.features.roles.common.*
import dev.inmo.micro_utils.ktor.client.UnifiedRequester
import kotlinx.serialization.KSerializer

class ClientRolesStorage<T : Role>(
    private val baseUrl: String,
    private val unifiedRequester: UnifiedRequester,
    private val serializer: KSerializer<T>
) : RolesStorage<T>,
    ReadRolesStorage<T> by ReadClientRolesStorage(
        baseUrl, unifiedRequester, serializer
    ),
    WriteRolesStorage<T> by WriteClientRolesStorage(
        baseUrl, unifiedRequester, serializer
    )
